unit uDaten;

interface

uses
  windows;
const
  c_xwide=5;
  c_ywide=5;

type
  r_koordinaten = record
    x,y: integer;
  end;

  r_single = record
    x,y,fluss:integer;
    used: boolean;
  end;

  r_feld= array[0..c_xwide,0..c_ywide] of r_single;

var
  v_data: r_feld;
  v_ablaufx, v_ablaufy: integer;

function calcfluss:integer;
function calcdisp:real;

procedure connect(vp_srcpos,vp_targetpos:tpoint);
function koordinaten(vp_x,vp_y:integer):tpoint;
function getorient(vp_pos:tpoint):integer; // 0: Spitze nach oben

function allconnected: boolean; // berprft ob alle Wege zum Ablauf fhren

implementation

uses
  classes;

function calcfluss:integer;
var
  vp_xrun, vp_yrun, vp_xpos,vp_ypos, vp_xposold, vp_yposold:integer;

begin
  // Reset
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      v_data[vp_xrun,vp_yrun].fluss:=1;

  // Alle Wasserwege verfolgen
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      if (vp_xrun<>v_ablaufx)or(vp_yrun<>v_ablaufy)
        then begin
          vp_xpos:=vp_xrun;
          vp_ypos:=vp_yrun;
          repeat
            vp_xposold:=vp_xpos;
            vp_yposold:=vp_ypos;
            vp_xpos:=v_data[vp_xposold,vp_yposold].x;
            vp_ypos:=v_data[vp_xposold,vp_yposold].y;
            v_data[vp_xpos,vp_ypos].fluss:=v_data[vp_xpos,vp_ypos].fluss+1;
          until ((vp_xpos=v_ablaufx)and(vp_ypos=v_ablaufy))or
                (vp_xpos<0)or(vp_xpos>c_xwide)or
                (vp_ypos<0)or(vp_ypos>c_ywide);
        end;

  // Summe bilden
  vp_xpos:=0;
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      vp_xpos:=vp_xpos+v_data[vp_xrun,vp_yrun].fluss;
  calcfluss:=vp_xpos;
end;

function calcdisp:real;
var
  vp_xrun, vp_yrun, vp_xpos,vp_ypos, vp_xposold, vp_yposold:integer;
  vp_disp:real;
begin
  // Reset
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      v_data[vp_xrun,vp_yrun].fluss:=1;

  // Alle Wasserwege verfolgen
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      if (vp_xrun<>v_ablaufx)or(vp_yrun<>v_ablaufy)
        then begin
          vp_xpos:=vp_xrun;
          vp_ypos:=vp_yrun;
          repeat
            vp_xposold:=vp_xpos;
            vp_yposold:=vp_ypos;
            vp_xpos:=v_data[vp_xposold,vp_yposold].x;
            vp_ypos:=v_data[vp_xposold,vp_yposold].y;
            v_data[vp_xpos,vp_ypos].fluss:=v_data[vp_xpos,vp_ypos].fluss+1;
          until (vp_xpos=v_ablaufx)and(vp_ypos=v_ablaufy);
        end;

  // Summe bilden
  vp_disp:=0;
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      vp_disp:=vp_disp+sqrt(v_data[vp_xrun,vp_yrun].fluss);
  vp_disp:=(vp_disp-sqrt(c_xwide*c_ywide)) / c_xwide*c_ywide;
  calcdisp:=vp_disp;
end;

procedure connect(vp_srcpos,vp_targetpos:tpoint);
begin
  v_data[vp_srcpos.x,vp_srcpos.y].x:=vp_targetpos.x;
  v_data[vp_srcpos.x,vp_srcpos.y].y:=vp_targetpos.y;
  v_data[vp_srcpos.x,vp_srcpos.y].used:=true;
end;

function koordinaten(vp_x,vp_y:integer):tpoint;
var
  vp_result:tpoint;
begin
  vp_result.x:=vp_x;
  vp_result.y:=vp_y;
  result:=vp_result;
end;

function getorient(vp_pos:tpoint):integer;
begin
  result:=(vp_pos.x + vp_pos.y) mod 2;
end;

function allconnected: boolean; // berprft ob alle Wege zum Ablauf fhren
var
  vp_connected:array[1..c_xwide,1..c_ywide] of byte;
  vp_xrun,vp_yrun,vp_xpos,vp_ypos, vp_xoldpos: integer;
  vp_nokreis:boolean;
begin
  for vp_yrun := 1 to c_ywide do
    for vp_xrun := 1 to c_xwide do
      vp_connected[vp_xrun,vp_yrun]:=0;
  vp_nokreis:=true;
  vp_connected[v_ablaufx,v_ablaufy]:=1;
  for vp_yrun:=1 to c_ywide do
    for vp_xrun:=1 to c_xwide do
      if (vp_nokreis)and((vp_xrun<>v_ablaufx)or(vp_yrun<>v_ablaufy))
      then
        begin
          vp_xpos:=vp_xrun;
          vp_ypos:=vp_yrun;
          repeat
            vp_connected[vp_xpos,vp_ypos]:=vp_connected[vp_xpos,vp_ypos]+2;
            vp_xoldpos:=vp_xpos;
            vp_xpos:=v_data[vp_xpos,vp_ypos].x;
            vp_ypos:=v_data[vp_xoldpos,vp_ypos].y;
          until (vp_connected[vp_xpos,vp_ypos]=1)or
                (vp_connected[vp_xpos,vp_ypos]=2);
          if (vp_connected[vp_xpos,vp_ypos]=2)
          then vp_nokreis:=false // Wasser fliet im Kreis
          else // Wasser fliet ab
            begin
              vp_xpos:=vp_xrun;
              vp_ypos:=vp_yrun;
              repeat
                vp_connected[vp_xpos,vp_ypos]:=1;
                vp_xoldpos:=vp_xpos;
                vp_xpos:=v_data[vp_xpos,vp_ypos].x;
                vp_ypos:=v_data[vp_xoldpos,vp_ypos].y;
              until (vp_connected[vp_xpos,vp_ypos]=1);
            end;
        end;
  result:=vp_nokreis;
end;

{***
function allconnected: boolean; // berprft ob alle Wege zum Ablauf fhren
var
  vp_connected:array[1..c_xwide,1..c_ywide] of byte;
  vp_xrun,vp_yrun: integer;
  vp_nokreis:boolean;
  vp_pos: tpoint;
begin
  for vp_yrun := 1 to c_ywide do
    for vp_xrun := 1 to c_xwide do
      vp_connected[vp_xrun,vp_yrun]:=0;
  vp_nokreis:=true;
  vp_connected[v_ablaufx,v_ablaufy]:=1;
  for vp_yrun:=1 to c_ywide do
    for vp_xrun:=1 to c_xwide do
      if (vp_nokreis)and((vp_xrun<>v_ablaufx)or(vp_yrun<>v_ablaufy))
      then
        begin

          vp_pos.x:=vp_xrun;
          vp_pos.y:=vp_yrun;
          repeat
            vp_connected[vp_pos.x,vp_pos.y]:=vp_connected[vp_pos.x,vp_pos.y]+2;
            vp_pos:=point(v_data[vp_pos.x,vp_pos.y].x,v_data[vp_pos.x,vp_pos.y].y);
          until (vp_connected[vp_pos.x,vp_pos.y]=1)or
                (vp_connected[vp_pos.x,vp_pos.y]=2);
          if (vp_connected[vp_pos.x,vp_pos.y]=2)
          then vp_nokreis:=false // Wasser fliet im Kreis
          else // Wasser fliet ab
            begin
              vp_pos.x:=vp_xrun;
              vp_pos.y:=vp_yrun;
              repeat
                vp_connected[vp_pos.x,vp_pos.y]:=1;
                vp_pos:=point(v_data[vp_pos.x,vp_pos.y].x,v_data[vp_pos.x,vp_pos.y].y);
              until (vp_connected[vp_pos.x,vp_pos.y]=1);
            end;
        end;
  result:=vp_nokreis;
end;

***}

end.
